commit:     06a04f2fd3e1fa9ae10489e605739ad60b77130f
Author:     Sv. Lockal <lockalsash <AT> gmail <DOT> com>
AuthorDate: Wed Mar 20 22:00:14 2024 +0000
Commit:     Sam James <sam <AT> gentoo <DOT> org>
CommitDate: Wed Jun 26 09:19:22 2024 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=06a04f2f

sci-libs/rpp: new package, add 6.1.1

Signed-off-by: Sv. Lockal <lockalsash <AT> gmail.com>
Signed-off-by: Sam James <sam <AT> gentoo.org>

 sci-libs/rpp/Manifest                              |  1 +
 .../rpp/files/rpp-6.1.1-skip-install-license.patch | 17 ++++
 sci-libs/rpp/metadata.xml                          | 14 ++++
 sci-libs/rpp/rpp-6.1.1.ebuild                      | 91 ++++++++++++++++++++++
 4 files changed, 123 insertions(+)

diff --git a/sci-libs/rpp/Manifest b/sci-libs/rpp/Manifest
new file mode 100644
index 000000000000..322ed39e26ea
--- /dev/null
+++ b/sci-libs/rpp/Manifest
@@ -0,0 +1 @@
+DIST rpp-6.1.1.tar.gz 37016755 BLAKE2B 
884090ab50e0a4a3aed4e52c5bbd934a8c5b62eca310471c30cf4c5a7cafdd36fed7894320b4d5246620b3c47e90fafd0f8160a7d4ed0295c7668c8d147f4b18
 SHA512 
a7c10bdd08739eba08209783decf0f4fd7c12194b9ebc63bd16e4cb998645110c089833efb83a77d4bed7f8599cf3a320608be28633f0dc956079f9d70e765f8

diff --git a/sci-libs/rpp/files/rpp-6.1.1-skip-install-license.patch 
b/sci-libs/rpp/files/rpp-6.1.1-skip-install-license.patch
new file mode 100644
index 000000000000..2253bb5aed67
--- /dev/null
+++ b/sci-libs/rpp/files/rpp-6.1.1-skip-install-license.patch
@@ -0,0 +1,17 @@
+Skip installation of license: it will be installed by ebuild to correct place
+--- a/CMakeLists.txt
++++ b/CMakeLists.txt
+@@ -343,13 +343,6 @@ install(FILES ${PROJECT_BINARY_DIR}/include/rpp_backend.h
+ install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/cmake DESTINATION 
${CMAKE_INSTALL_DATADIR}/${PROJECT_NAME}/test COMPONENT test)
+ install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/utilities/test_suite/ 
DESTINATION ${CMAKE_INSTALL_DATADIR}/${PROJECT_NAME}/test COMPONENT test)
+ 
+-# set license information
+-set(CPACK_RESOURCE_FILE_LICENSE  "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
+-install(FILES ${CPACK_RESOURCE_FILE_LICENSE} DESTINATION 
${CMAKE_INSTALL_DOCDIR} COMPONENT runtime)
+-install(FILES ${CPACK_RESOURCE_FILE_LICENSE} DESTINATION 
${CMAKE_INSTALL_DOCDIR}-asan COMPONENT asan)
+-install(FILES ${CPACK_RESOURCE_FILE_LICENSE} DESTINATION 
${CMAKE_INSTALL_DOCDIR}-dev COMPONENT dev)
+-install(FILES ${CPACK_RESOURCE_FILE_LICENSE} DESTINATION 
${CMAKE_INSTALL_DOCDIR}-test COMPONENT test)
+-
+ # CTest - Needs RPP Installed
+ enable_testing()
+ include(CTest)

diff --git a/sci-libs/rpp/metadata.xml b/sci-libs/rpp/metadata.xml
new file mode 100644
index 000000000000..944efd183177
--- /dev/null
+++ b/sci-libs/rpp/metadata.xml
@@ -0,0 +1,14 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE pkgmetadata SYSTEM "https://www.gentoo.org/dtd/metadata.dtd";>
+<pkgmetadata>
+  <maintainer type="project">
+    <email>[email protected]</email>
+  </maintainer>
+  <maintainer type="person">
+    <email>[email protected]</email>
+    <name>Sv. Lockal</name>
+  </maintainer>
+  <upstream>
+    <remote-id type="github">ROCm/rpp</remote-id>
+  </upstream>
+</pkgmetadata>

diff --git a/sci-libs/rpp/rpp-6.1.1.ebuild b/sci-libs/rpp/rpp-6.1.1.ebuild
new file mode 100644
index 000000000000..d38645f9ff56
--- /dev/null
+++ b/sci-libs/rpp/rpp-6.1.1.ebuild
@@ -0,0 +1,91 @@
+# Copyright 1999-2024 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+ROCM_VERSION=${PV}
+
+inherit cmake flag-o-matic rocm
+
+DESCRIPTION="AMD ROCm Performance Primitives (RPP) high-performance computer 
vision library"
+HOMEPAGE="https://github.com/ROCm/rpp";
+SRC_URI="https://github.com/ROCm/rpp/archive/refs/tags/rocm-${PV}.tar.gz -> 
rpp-${PV}.tar.gz"
+S="${WORKDIR}/${PN}-rocm-${PV}"
+
+LICENSE="BSD"
+SLOT="0/$(ver_cut 1-2)"
+KEYWORDS="~amd64"
+
+# pkgcheck warning: RequiredUseDefaults
+REQUIRED_USE="
+       cpu_flags_x86_avx2 cpu_flags_x86_fma3 cpu_flags_x86_f16c
+       ${ROCM_REQUIRED_USE}
+"
+
+RDEPEND="
+       dev-util/hip:${SLOT}
+"
+DEPEND="${RDEPEND}"
+BDEPEND="
+       >=dev-build/cmake-3.22
+       >=dev-libs/half-1.12.0-r1
+       test? ( dev-cpp/gtest )
+"
+
+IUSE="cpu_flags_x86_avx2 cpu_flags_x86_fma3 cpu_flags_x86_f16c test"
+RESTRICT="!test? ( test )"
+
+PATCHES=(
+       "${FILESDIR}"/${PN}-6.1.1-skip-install-license.patch
+)
+
+DOCS=( CHANGELOG.md LICENSE README.md )
+
+rcc_test_wrapper() {
+       local S="${WORKDIR}/${PN}-rocm-${PV}/utilities/rpp-unittests/HIP_NEW"
+       local CMAKE_USE_DIR="${S}"
+       local BUILD_DIR="${BUILD_DIR}/utilities/rpp-unittests/HIP_NEW"
+       cd "${S}" || die
+       $@
+}
+
+src_prepare() {
+       sed -e "s:\${ROCM_PATH}/llvm/bin/clang++:hipcc:" \
+               -i CMakeLists.txt || die
+
+       cmake_src_prepare
+       use test && rcc_test_wrapper cmake_src_prepare
+}
+
+src_configure() {
+       local mycmakeargs=(
+               -DCMAKE_SKIP_RPATH=ON
+               -DAMDGPU_TARGETS="$(get_amdgpu_flags)"
+               -DROCM_PATH=/usr
+               -DBACKEND=HIP
+               -DBUILD_WITH_AMD_ADVANCE=OFF
+       )
+
+       cmake_src_configure
+
+       if use test; then
+               append-cxxflags -I"${S}/include"
+               append-ldflags -L"${BUILD_DIR}/lib64"
+               local mycmakeargs=(-DROCM_PATH=/usr)
+               use test && rcc_test_wrapper cmake_src_configure
+       fi
+}
+
+src_compile() {
+       cmake_src_compile
+       use test && rcc_test_wrapper cmake_src_compile
+}
+
+src_test() {
+       check_amdgpu
+
+       cd "${BUILD_DIR}"/utilities/rpp-unittests/HIP_NEW || die
+       for params in "0 0" "0 1" "1 1" "2 1" "5 1" "0 2" "0 3" "0 4" "0 5" "0 
8"; do
+               LD_LIBRARY_PATH="${BUILD_DIR}"/lib64 
./uniqueFunctionalities_hip $params || die
+       done
+}

Reply via email to